# Fetching a list of Billing Milestones

Gets a list of billing milestones.


This endpoint returns structured Billing Milestones objects.
As with all Kantata OX API endpoints, the returned data will be referenced in sorted order in the results array
and will be indexed by ID in the billing_milestones top-level JSON key.
Please see our Response Format section for more information.

Endpoint: GET /billing_milestones
Version: 1.0.0

## Query parameters:

  - `date_between` (string)
    Filter by a range of invoice dates. Format as YYYY-MM-DD:YYYY-MM-DD. The filter is inclusive.

  - `external_reference_external_message` (string)
    Filter the objects based on the external message of their associated external references. This is an exact match.

  - `external_reference_external_status` (string)
    Filter by the status of the external object in the external system.

  - `external_reference_service_model` (string)
    Filter by the type of the external object this external reference belongs to.

  - `external_reference_service_model_ref` (integer)
    Filter by the id of the external object this external reference belongs to.

  - `external_reference_service_model_refs` (string)
    Filter for objects that correlate to the specified external object IDs. Provide a comma-separated list of up to 200 external IDs.

  - `external_reference_service_name` (string)
    Filter by the name of the provider for integration.

  - `external_reference_status` (string)
    Filter by the status of the integration, this can be successful or fail.

  - `has_external_references` (boolean)
    Filter by whether or not the object has external references.

  - `include` (string)
    Any of the below associations can be included in your request by providing the include param, e.g. include=association1,association2.
- external_references (ExternalReference) - Includes references to external integrations for this object.
- invoices (Invoice) - Retrieves the invoices that the billing milestones are on. The response will include invoice_ids, which references the data in the invoices top-level key.
- story (Story) - Retrieves the task associated with the billing milestone. The response will include story_id, which references the data in the stories top-level key.
- workspace (Workspace) - Retrieves the project that the billing milestone is in. The response will include workspace_id, which references the data in the workspaces top-level key.

  - `only` (string)
    Allows you to request one or more resources directly by ID. Multiple IDs can be supplied
in a comma separated list, like GET /api/v1/workspaces.json?only=5,6,7.

  - `order` (string)
    Supply order with the name of a valid sort field for the endpoint and a direction.

Valid values: created_at:asc and created_at:desc.

  - `page` (integer)

  - `per_page` (integer)

  - `story_ids` (string)
    Filter for billing milestones associated to specific tasks. Provide a comma-separated list of task IDs. For example, 10,20.

  - `without_external_reference_service_name` (string)
    Exclude by the existence of an external reference with the specified service name.

  - `workspace_ids` (string)
    Filter by the workspace. Provide a comma-separated list of workspace IDs. For example, 10,20.

## Response 200 fields (application/json):

  - `count` (integer)

  - `meta` (object)

  - `meta.count` (integer)

  - `meta.page_count` (integer)

  - `meta.page_number` (integer)

  - `meta.page_size` (integer)

  - `results` (array)

  - `results.key` (string)

  - `results.id` (string)

  - `billing_milestones` (object)

  - `external_references` (object)

  - `workspaces` (object)

  - `stories` (object)

  - `invoices` (object)

## Response 400 fields (application/json):

  - `errors` (array)

  - `errors.type` (string)

  - `errors.message` (string)


